function [Iref, Idef, h, u, v] = calculs_graphs(Iref,Idef)

% convert images to double to prevent rounding errors
Iref = double(Iref);
Idef = double(Idef);

% get two independent carrier peaks from reference image
[kr, ku] = findorthcarrierpks(Iref, 4*pi/min(size(Iref)), Inf);

% extract carrier signals from reference image and store them for later use
krad = sqrt(sum((kr-ku).^2))/2;
fIref = fft2(Iref);
cr = getcarrier(fIref, kr, krad);
cu = getcarrier(fIref, ku, krad);

% get displacement field and height profile
tic

fIdef = fft2(Idef);
[u,v] = fcd_dispfield(fIdef,cr,cu);
h = fftinvgrad(-u,-v);
% h = invgrad2(-u,-v);

toc

end
