clear all
clc
warning('MATLAB:imagesci:tifftagsread:zeroComponentCount', 'off')
% Théoreme de Wiener Kintchine

format compact
format long
figure(1), clf
figure(2), clf
figure(3), clf
figure(4), clf
figure(5), clf

%% Choix


nb_enregistrements = 10;

% D = dir('/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique/test_bougie_4');

film = 0;               % 1 = visu film
freq = 200;             % freq en Hz
px =  0.05/161.77;       % fer taille px en m

filtre_gauss = 4;
filtre_derrivee = 2;
visu = 166;
v1min = -0.5;
v1max = 1.5;

%%


T_fer = [150 200 250 300 350 400 450];
% T_fer = [150];
nb_temp = length(T_fer);
nb_flame = 3;
V_enr = zeros(nb_enregistrements, 2, nb_temp);
V_brute = zeros(2,(800-2)*nb_enregistrements*nb_temp);
V_flame = zeros(2,(800-2)*nb_enregistrements*nb_flame);

V_flame(1,1:(800-2)*nb_enregistrements) = 1;
V_flame(1,(800-2)*nb_enregistrements+1:(800-2)*nb_enregistrements*2) = 2;
V_flame(1,(800-2)*nb_enregistrements*2+1:(800-2)*nb_enregistrements*3) = 3;

X = linspace(v1min, v1max, 1000);

D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/']);
% file = Tiff([D(3).folder,'/ref.tiff'],'r');
img = read(Tiff([D(3).folder,'/ref.tiff'],'r'));
% img = imread([D(3).folder,'/ref.tiff']);
lx = length(img(1,:));
ly = length(img(:,1));
nb_img = length(D)-2;
[maxi, ind_maxi] = max(img(50,:));
close(Tiff([D(3).folder,'/ref.tiff'],'r'));



for k=1:(nb_temp+nb_flame)
    if k<=nb_temp
        V_brute(1,(800-2)*nb_enregistrements*(k-1)+1:(800-2)*nb_enregistrements*k) = T_fer(k);
    end
    for l = 1:nb_enregistrements

%            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/briquet/briquet_allume_200Hz_',num2str(l)]);
%            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/bougie/bougie_200Hz_',num2str(l)]);
        
        if k==nb_temp+1
            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/bougie/bougie_200Hz_',num2str(l)]);
        elseif k==nb_temp+2
            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/briquet/briquet_allume_200Hz_',num2str(l)]);
        elseif k==nb_temp+3
            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/briquet/briquet_eteint_200Hz_',num2str(l)]);
        else
            D = dir(['/home/charles-alexis/Documents/MATLAB/PSE/data/Sh_optique_4/fer_',num2str(T_fer(k)),'°C_200Hz_',num2str(l)]);
        end    
        
        tif = Tiff([D(3).folder,'/', D(3).name],'r');
        img = read(tif);

        lx = length(img(1,:));
        ly = length(img(:,1));
        nb_img = length(D)-2;
        close(tif);
%         [maxi, ind_maxi] = max(img(60,:));

%         img(:,ind_maxi) = zeros(ly,1);

        slice = zeros(ly,nb_img,'uint8');
        for i=1:nb_img
            tif = Tiff([D(i+2).folder,'/', D(i+2).name],'r');
            img = imgaussfilt(read(tif),filtre_gauss);
            slice(:,i) = img(:,ind_maxi);
            img(:,ind_maxi) = zeros(ly,1); 
            close(tif);
        end

        x1 = 1;
        x2 = nb_img;
        y1 = 1;
        y2 = 300;

        data = slice(y1:y2,x1:x2); %slice(20:350,20:nb_img)      
        
        deriv_y_data = zeros(length(data(:,1))-1,length(data(1,:))-1);

        for i=1:length(deriv_y_data(:,1))
            for j=1:length(deriv_y_data(1,:))
                deriv = data(i+1,j) - data(i,j);
                if deriv > filtre_derrivee
                    deriv_y_data(i,j) = deriv;
                end
            end
        end
        
        figure(1)
        subplot(nb_enregistrements,nb_temp+nb_flame,(l-1)*(nb_temp+nb_flame)+k)
        imshow(data)
%         imagesc(deriv_y_data)
        if k==nb_temp+1
            title(['bougie enr :',num2str(l)])
        elseif k==nb_temp+2
            title(['briquet allume enr :',num2str(l)])
        elseif k==nb_temp+3
            title(['briquet eteint enr :',num2str(l)])
        else
            title([num2str(T_fer(k)),' enr : ',num2str(l)])
        end    

        colormap gray
        hold on
        
        
        C = zeros(2*length(deriv_y_data(:,1))-1, length(deriv_y_data(1,:))-1);
        DY = zeros(2*length(deriv_y_data(:,1))-1, length(deriv_y_data(1,:))-1);

        max_C = zeros(2, length(deriv_y_data(1,:))-1);
        dy = zeros(1, length(deriv_y_data(1,:))-1);

        for i=1:length(deriv_y_data(1,:))-1
            d1 = double(deriv_y_data(:,i))-mean(double(deriv_y_data(:,i)));
            d2 = double(deriv_y_data(:,i+1))-mean(double(deriv_y_data(:,i+1)));
            [C(:,i), DY(:,i)] = xcorr(d1,d2);
            [max_C(1,i), max_C(2,i)] = max(C(:,i));         % [max ind_max]
            dy(i) = DY(max_C(2,i),i);
        end
        v1_brute = dy*px*freq;
%         v1_brute_sum(1+(l-1)*(800-2):l*(800-2)) = v1_brute;
        v1_final = v1_brute(v1_brute>v1min & v1_brute<v1max);
        
        v1moy = mean(v1_final);
        v1var = var(v1_final);
        
        if k>nb_temp
            V_flame(2,(800-2)*(l-1)+1+(800-2)*nb_enregistrements*(k-nb_temp-1):(800-2)*l+(800-2)*nb_enregistrements*(k-nb_temp-1)) = v1_brute;
        else
            V_enr(l,1,k) = v1moy;
            V_enr(l,2,k) = v1var;
            V_brute(2,(800-2)*(l-1)+1+(800-2)*nb_enregistrements*(k-1):(800-2)*l+(800-2)*nb_enregistrements*(k-1)) = v1_brute;
        end    
        
        
        
        

        figure(2)
        subplot(nb_enregistrements,nb_temp+nb_flame,(l-1)*(nb_temp+nb_flame)+k)
        [Hy Hx] = hist(v1_final,100);
        hist(v1_final,100);
        hold on
        gauss = max(Hy)*exp(-(X-v1moy).^2/2/v1var);
        plot(X, gauss)
        hold on
        xlim([v1min v1max])
        if k==nb_temp+1
            title(['bougie enr :',num2str(l)])
        elseif k==nb_temp+2
            title(['briquet allume enr :',num2str(l)])
        elseif k==nb_temp+3
            title(['briquet eteint enr :',num2str(l)])
        else
            title([num2str(T_fer(k)),' enr : ',num2str(l)])
        end    
%         ylim([0 1.1*max(Hy)])

        
%         fourier = fftshift(log(abs(fft2(data-mean(mean(data))))));
%         yc=(y1:y2)-(y2-y1)/2-y1;
%         xc=(x1:x2)-(x2-x1)/2-x1;
% 
%         [XC,YC]=meshgrid(xc,yc);
%         [THETA,RHO]=cart2pol(XC,YC);
%         pastheta=pi/1000;
%         theta=-pi:pastheta:(pi-pastheta);
%         Ntheta=length(theta);
%         figure(21)
%         surf(fourier)
%         view(2)
%         shading interp
% 
%         for cpttheta=1:Ntheta,
%             I(cpttheta)=sum(fourier((THETA>theta(cpttheta)) & (THETA<=theta(cpttheta)+pastheta) & (RHO>10)));
%         end
%         
%         [Imax ind_angle] = max(I(theta>0.05 & theta<0.2))
%         theta_slice = theta(theta>0.05 & theta<0.2);
%         angle = theta_slice(ind_angle)
% 
%         v3 = 1/tan(angle)*px*freq/pi;
%         Vfft(l,k) = v3;

    end
end



T = zeros(1, nb_enregistrements*nb_temp);
Y = zeros(1, nb_enregistrements*nb_temp);
for i=1:nb_enregistrements
    T((i-1)*(nb_temp)+1:i*(nb_temp)) = T_fer;
    Y((i-1)*(nb_temp)+1:i*(nb_temp)) = V_enr(i,1,:);
end

V_final = V_brute(:,V_brute(2,:)>v1min & V_brute(2,:)<v1max);
V_moy = zeros(1,nb_temp);
V_var = zeros(1,nb_temp);
V_enr_moy = zeros(1,nb_temp);
V_enr_var = zeros(1,nb_temp);
for i=1:nb_temp
    V_moy(i) = mean(V_final(2,V_final(1,:) == T_fer(i)));
    V_var(i) = var(V_final(2,V_final(1,:) == T_fer(i)));
    V_enr_moy(i) = mean(V_enr(:,1,i));
    V_enr_var(i) = var(V_enr(:,1,i));
end

T_fer = T_fer;           % ajout air
P_final = polyfit(V_final(1,:),V_final(2,:),1)
P_final_moy = polyfit(T_fer,V_moy,1)
P_enr = polyfit(T,Y,1)
P_enr_moy = polyfit(T_fer,V_enr_moy,1)



V_flame_err1 = V_flame(:,V_flame(2,:)>v1min & V_flame(2,:)<v1max & V_flame(1,:) == 1);
V_flame_err2 = V_flame(:,V_flame(2,:)>0.2 & V_flame(2,:)<v1max & V_flame(1,:) == 2);    % Valeurs abérantes cf distributions
V_flame_err3 = V_flame(:,V_flame(2,:)>v1min & V_flame(2,:)<v1max & V_flame(1,:) == 3);

V_flame_final = [V_flame_err1 V_flame_err2 V_flame_err3];
V_flame_moy = zeros(1,nb_flame);
V_flame_var = zeros(1,nb_flame);
T_flame = [1 2 3];
for i=1:nb_flame
    V_flame_moy(i) = mean(V_flame_final(2,V_flame_final(1,:) == T_flame(i)));
    V_flame_var(i) = var(V_flame_final(2,V_flame_final(1,:) == T_flame(i)));
    T_flame(i) = (V_flame_moy(i) - P_final(2)) / P_final(1);
end


figure(3)
% plot(T,Y,'.k')
% hold on
plot(T_fer,V_enr_moy,'xk','MarkerSize',10)
hold on
plot(T_fer,V_enr_moy + V_enr_var.^0.5,'^k','MarkerSize',10)
hold on
plot(T_fer,V_enr_moy - V_enr_var.^0.5,'vk','MarkerSize',10)
hold on

plot(T_fer,V_moy,'xr','MarkerSize',10)
hold on
plot(T_fer,V_moy + V_var.^0.5,'^r','MarkerSize',10)
hold on
plot(T_fer,V_moy - V_var.^0.5,'vr','MarkerSize',10)
hold on

T_crop = 1100
plot([T_fer,T_crop],polyval(P_final,[T_fer,T_crop]),'r')
% hold on
% plot([T_fer,T_crop],polyval(P_final_moy,[T_fer,T_crop]),':r','LineWidth',3)
% hold on
% plot([T_fer,T_crop],polyval(P_enr,[T_fer,T_crop]),'k')
% hold on
% plot([T_fer,T_crop],polyval(P_enr_moy,[T_fer,T_crop]),':k','LineWidth',3)
% hold on

plot(T_flame,V_flame_moy,'xb','MarkerSize',10)
hold on
plot(T_flame,V_flame_moy + V_flame_var.^0.5,'^b','MarkerSize',10)
hold on
plot(T_flame,V_flame_moy - V_flame_var.^0.5,'vb','MarkerSize',10)
hold on

xlim([100 T_crop+50])

% C = zeros(nb_temp,2);
% C(:,1) = V_final(:,1);
% C(:,2) = T_fer;
[R,P] = corrcoef(V_final.');

xlabel('Température de la source (°C)')
ylabel("Vitesse moyenne de l'air (m/s)")
title("Evolution de la vitesse d'ascension de l'air")








% V(:,:,1) =
%    0.260300695663070   0.010341144642207
%    0.277917275675035   0.013643813538983
%    0.263069178654432   0.006571082929512
%    0.279862999938184   0.011086213050324
%    0.312503838340474   0.010740157780682
%    0.258159436899793   0.008169992687396
%    0.259676540865105   0.016988041376745
%    0.278795024670455   0.018156942945005
%    0.229382653892559   0.013894438771912
%    0.311012548680224   0.017078026684658
% V(:,:,2) =
%    0.324534833405452   0.016273778924898
%    0.326764520723327   0.022070762434331
%    0.340829909264811   0.010791351732863
%    0.301033719800155   0.013036244804594
%    0.321444025468256   0.014703803393704
%    0.374624560025820   0.011488345568753
%    0.328116895584319   0.009830621260183
%    0.372706205890024   0.013333578629879
%    0.321884140514329   0.010281912083672
%    0.278863397685450   0.021465885121254
% V(:,:,3) =
%    0.339336803906363   0.031237379834023
%    0.302713960890050   0.013387488330802
%    0.336809029534640   0.013549713289723
%    0.349481526461187   0.018975854355624
%    0.248138361600937   0.009023858585877
%    0.334887539602852   0.010379100778801
%    0.306997102975301   0.019575892616323
%    0.219674372033391   0.010546183671661
%    0.379513750348887   0.014581141811750
%    0.317939184069069   0.011814885360550
% V(:,:,4) =
%    0.369849220959239   0.024447019964884
%    0.351509879541122   0.019989974532039
%    0.360392245748723   0.017128708271800
%    0.363912075769146   0.015907175406193
%    0.345443240039415   0.028834343326223
%    0.346052180528027   0.016022425567308
%    0.367071196710493   0.022750400498169
%    0.377551383149684   0.011223901008812
%    0.417078674170876   0.022070039377559
%    0.422597739776449   0.026357492134518
% V(:,:,5) =
%    0.330222379609583   0.017459851669000
%    0.353828311616177   0.016641448698502
%    0.410053811860632   0.026258215400643
%    0.364537873932302   0.017746088533646
%    0.381455613118386   0.034517388047753
%    0.317976289733842   0.024314933562058
%    0.383598902890200   0.031909317508950
%    0.402206435463528   0.019633522497092
%    0.343575476158478   0.014060372673184
%    0.372529062265191   0.016775343625381
% V(:,:,6) =
%    0.419991524915046   0.019088285420376
%    0.358837912708413   0.017285355783841
%    0.316794039908555   0.014815931219418
%    0.393184411058111   0.015629499355265
%    0.327147835284721   0.015411108737014
%    0.422181469347198   0.026509486473291
%    0.361768659591865   0.027439293000267
%    0.372055100636560   0.016216489739472
%    0.375136556271029   0.022104493810266
%    0.335796999758883   0.023133072902450
% V(:,:,7) =
%    0.359995040789966   0.017995889069137
%    0.385937782532074   0.017895872301687
%    0.368720327155489   0.017285226866742
%    0.405551465698587   0.026952514539574
%    0.358431262992918   0.011286718288149
%    0.364583812846975   0.017298211444401
%    0.373538668649010   0.025407917780912
%    0.355915995624928   0.013584226003271
%    0.394645533223739   0.036282827555299
%    0.411504907808432   0.018227221485502
% 
% 
% P =
%    0.000318079352828   0.247435270336023

% Bougie
% V =
%    0.453661206582020   0.037812442461820
%    0.469572435675680   0.046919352138880
%    0.431351521807625   0.050036951567489
%    0.356357637867847   0.023770865737981
%    0.375818621153174   0.025877268525062
%    0.467659432105200   0.038306717105612
%    0.445104505215158   0.044497001038252
%    0.416499036782641   0.029992604475986
%    0.445959430938105   0.040581257862336
%    0.449025708653575   0.048283389535269
% mean(V) = 0.431100953678103
% var(V) = 0.001435521248363
% 
% V_bougie = 0.000318079352828*T_bougie  + 0.247435270336023
% T_briquet =  577.4209539510614 + 20 = 597.4209539510614


% Briquet
% V =
%    0.484634765936690   0.025807507335980
%    0.565499882738050   0.037363026578439
%    0.653213141219463   0.033826065273274
%    0.602481941334209   0.037428166775393
%    0.577811001845217   0.046955115620300
%    0.540370466323042   0.054536018258082
%    0.476986846523843   0.027753623997598
%    0.516775212429064   0.027502359047520
%    0.575354953593526   0.035608046126680
%    0.586474312788724   0.052875965490091
% 
% mean(V) = 0.557960252473183
% var(V) = 0.002951194075394
%
% V_briquet = 0.000318079352828*T_briquet  + 0.247435270336023
% T_briquet =  976.2500438218480 + 20 = 996.2500438218480





