
clear all
clc

format compact
format long
close all

ligne = 586; %586
filtre_gauss = 4;
px = 2*10^-2/640;
crop_phi = 80;



Blanc = imread('/home/charles-alexis/Documents/MATLAB/PSE_michelson/blanc.tiff');
Img = imread('/home/charles-alexis/Documents/MATLAB/PSE_michelson/cliché_1.tiff');
[M N] = size(Img);
Img = Img(800:1750,650:1350);
Blanc = Blanc(800:1750,650:1350);

I = imgaussfilt(Img,filtre_gauss);
B = imgaussfilt(Blanc,filtre_gauss);


l = length(I(1,:));
h = length(I(:,1));

r0 = 651;



figure(1)
subplot(1,3,1)
Bex = B;
Bex(ligne,:) = 250;
imshow(Bex)
hold on
subplot(1,3,2)
Iex = I;
Iex(ligne,:) = 250;
imshow(Iex)

[i1,d1] = lowpass(im2double(I)',100,l,'ImpulseResponse','iir','Steepness',0.9);
[i2,d2] = highpass(i1,2,l,'ImpulseResponse','iir','Steepness',0.9);

[b1,e1] = lowpass(im2double(B)',100,l,'ImpulseResponse','iir','Steepness',0.9);
[b2,e2] = highpass(b1,2,l,'ImpulseResponse','iir','Steepness',0.9);


i2 = i2';
b2 = b2';

phi = zeros(h,l);
phib = zeros(h,l);
ind0=1;
ind1 = 1;
ind2 = 1;
ind0b=1;
ind1b = 1;
ind2b = 1;
for i=1:h
    count = 0;
    countb = 0;
    for j=1:l-1
        if i2(i,j)*i2(i,j+1)<=0
            count = count +1;
            phi(i,j) = count*pi;
            ind1 = ind2;
            ind2 = j;
            for k=ind1+1:ind2-1
                phi(i,k) = phi(i,ind1)+(phi(i,ind2)-phi(i,ind1))/(ind2-ind1)*(k-ind1);
            end
            if count==1
                ind0 = j;
            end
        end
        if b2(i,j)*b2(i,j+1)<=0
            countb = countb +1;
            phib(i,j) = countb*pi;
            ind1b = ind2b;
            ind2b = j;
            for k=ind1b+1:ind2b-1
                phib(i,k) = phib(i,ind1b)+(phib(i,ind2b)-phib(i,ind1b))/(ind2b-ind1b)*(k-ind1b);
            end
            if countb==1
                ind0b = j;
            end
        end
    end
end


for i=1:h
    for j=500:l
        if phi(i,j)==0
            phi(i,j)=max(phi(i,:));
        end
    end
    for j=1:400
        if phi(i,j)==0
            phi(i,j)=phi(i,ind0b);
        end
    end
    for j=500:l
        if phib(i,j)==0
            phib(i,j)=max(phib(i,:));
        end
    end
    for j=1:400
        if phib(i,j)==0
            phib(i,j)=phib(i,ind0b);
        end
    end
end

phif = phi-phib;


for i=1:h
    [mini, i_mini] = min(phif(i,100:400));
    phif(i,:) = phif(i,:)-mini;
    for j=1:i_mini+100
        phif(i,j) = 0;
    end
end


dphi = zeros(h,l-1);
for i=1:h
    for j=crop_phi:l-1
        dphi(i,j) = (phif(i,j+1)-phif(i,j))/px;
    end
end

dphi = lowpass(dphi',10,length(dphi(ligne,:)),'ImpulseResponse','iir','Steepness',0.9);
dphi = dphi';

n = zeros(h,l-1);


for i=1:h
    i/h*100
    for j=crop_phi+6:r0
        integ = zeros(1,l-1);
        for k=crop_phi:j-5
            integ(k) = dphi(i,k)/(((k-r0)*px)^2 - ((j-r0)*px)^2)^0.5;
        end
        n(i,j) = -532*10^-9/2/pi^2*sum(integ(1:j))*px;
    end
end



n0 = 1.000272;
nr = n + n0;

T = 0.082./(nr-1);

for i=1:h
    for j=crop_phi:l-1
        if T(i,j)<0 || T(i,j)>5000
            T(i,j) = 400;
        end
    end
end


figure(2)
plot(1:l,i2(ligne,:)*max(phif(ligne,:)))
hold on
plot(1:l,phif(ligne,:))
title('Traitement des données')
xlabel('pixel')
ylabel('Phase (rad) / Intensité (UA)')

legend('Intensité lumineuse', 'Somme de phase')



figure(3)
x = 1:588;
plot(-(x-588)*px*100,T(ligne,1:588))

xlabel('Distance au centre (cm)')
ylabel('Température (K)')
title('Température')

figure(4)
plot(1:l-1,nr(ligne,:))
title('Indice optique')

figure(6)
plot(1:l-1,dphi(ligne,:))
figure(7)

figure(1)
subplot(1,3,3)
imagesc(phi)
colormap gray
axis image

figure(5)
imagesc(T)
colormap gray
axis image